﻿using UnityEngine;
using System.Collections;

public class MonsterController : MonoBehaviour {
	private Vector3 guardPos;
	private float dxt = 0;
	public float guardDistance = 1.0f;
	public float speed = 1.0f;

	GameObject player;
	private Rigidbody2D physiscBody;

	void startGuard()
	{
		guardPos = transform.position;
		dxt = 0;
		player = GameObject.FindGameObjectWithTag ("Player");
	}
	// Use this for initialization
	void Start () {
		startGuard ();
		physiscBody = GetComponent<Rigidbody2D>();
	}
	
	// Update is called once per frame
	/*
	 * GuardDistance = 1.0;
	 * speed = 1.0
	 * Kinematic actor
	 	void Update () {
		float dt = Time.deltaTime;

		float dx = Mathf.Sin(dxt * speed) * guardDistance;
		float dy = Mathf.Sin(Time.time * 20.0f) * 0.2f;
		transform.position = guardPos + new Vector3 (dx, dy, 0);
		dxt += dt;
	}
	*/

	void FixedUpdate () {
		Vector3 playerPos = player.transform.position;
		Vector3 pos = transform.position;
		Vector3 dir = playerPos - pos;
		float dist = dir.magnitude;
		if (dist < guardDistance) {
			Vector3 oldVel = physiscBody.velocity;
			dir = new Vector3(Mathf.Sign(dir.x) * speed,0,0);
			Vector3 newVel = oldVel + dir;
			physiscBody.velocity = newVel;
		}

	}

	void OnTriggerEnter2D(Collider2D other)
	{
		if (other.gameObject.tag == "Player")
		{
			other.gameObject.GetComponent<PlayerStatus>().decreaseLife();
			Destroy(gameObject);
		}
	}
}
